#include <STC12C5A60S2.H>
#include <intrins.h>
#define		DS1302_CLK P34			//DS1302_CLK
#define		DS1302_DAT P35			//DS1302_DAT
#define		DS1302_RST P36			//DS1302_RST
#define		DS18B20_DAT P11			//DS18B20_DAT
#define		LED_R P25				//LED_R
#define		LED_G P26				//LED_G
#define		LED_B P27				//LED_B
#define		Buzzer P10				//Buzzer
#define		Colon P07				//Colon
#define		B0 P15					//B0
#define		B1 P16					//B1
#define		B2 P17					//B2
#define		Write_Protect	0x8e	//дĴַ
#define		Write_TCR		0x90	//дĴַ
#define		Write_Year		0x8c	//дĴַ
#define		Write_Day		0x8a	//дڼĴַ
#define		Write_Month		0x88	//д¼Ĵַ
#define		Write_Date		0x86	//дռĴַ
#define		Write_Hour		0x84	//дСʱĴַ
#define		Write_Minute	0x82	//дӼĴַ
#define		Write_Second	0x80	//дӼĴַ
#define		Read_Year		0x8d	//Ĵַ
#define		Read_Day		0x8b	//ڼĴַ
#define		Read_Month		0x89	//¼Ĵַ
#define		Read_Date		0x87	//ռĴַ
#define		Read_Hour		0x85	//СʱĴַ
#define		Read_Minute		0x83	//ӼĴַ
#define		Read_Second		0x81	//ӼĴַ
#define		TCS_OFF			0xa0	//DS1302緽ʽΪر
#define		TCS_1D2K		0xa5	//DS1302緽ʽΪ1ܣ2K
#define		TCS_1D4K		0xa6	//DS1302緽ʽΪ1ܣ4K
#define		TCS_1D8K		0xa7	//DS1302緽ʽΪ1ܣ8K
#define		TCS_2D2K		0xa9	//DS1302緽ʽΪ2ܣ2K
#define		TCS_2D4K		0xaa	//DS1302緽ʽΪ2ܣ4K
#define		TCS_2D8K		0xab	//DS1302緽ʽΪ2ܣ8K
#define		Init_Year		0x19	//ʼ
#define		Init_Day		0x02	//ʼ
#define		Init_Month		0x10	//ʼ
#define		Init_Date		0x01	//ʼ
#define		Init_Hour		0x00	//ʼСʱ
#define		Init_Minute		0x00	//ʼ
sbit ACC_7=ACC^7;
char Temp;
unsigned char Counter_50ms_Timer0,Counter_50ms_Timer1,ss,Time_Mode,Step,Temp_Min,Temp_Max;
unsigned char code Display_Code[]={0x3f,0x06,0x5b,0x4f,0x66,0x6d,0x7d,0x07,0x7f,0x6f,0x77,0x7c,0x39,0x5e,0x79,0x71};
unsigned char code Display_Code_Turn[]={0x3f,0x30,0x5b,0x79,0x74,0x6d,0x6f,0x38,0x7f,0x7d,0x7e,0x67,0x0f,0x73,0x4f,0x4e};
bit Clock_Mode,Temperature_Mode,B0_Flag,B1_Flag,B2_Flag,Temperature_Mode,Set_Mode,Light_Mode,Light_Temp,Power_Mode;

/*----------------------------ʱ10us@STC-Y3@12MHz----------------------------*/
void Delay_10us(void)
{
	unsigned char i;
	_nop_();
	_nop_();
	i=27;
	while(--i);
}

/*----------------------------ʱx10us----------------------------*/
void Delay_x10us(unsigned char x)
{
	while(x--)
		Delay_10us();
}

/********************************ַݷӳ********************************/
void Write_DS1302 (unsigned char addr,dat)
{
	unsigned char i,temp;				//ַͱ
	P3M0=P3M0|0x20;						//ö˿״̬
	DS1302_RST=0;						//λDS1302_RSTֹDS1302ݴ
	DS1302_CLK=0;						//DS1302_CLK
	DS1302_RST=1;						//λDS1302_RSTʹDS1302ݴ
/********************************͵ַ********************************/
	for (i=8;i>0;i--)					//ѭλ8
	{
		DS1302_CLK=0;					//DS1302_CLK
		temp=addr;						//ѵֵַʱ
		DS1302_DAT=(bit)(temp&0x01);	//ַλŵDS1302_DAT
		DS1302_CLK=1;					//DS1302_CLK
		addr>>=1;						//ַһλ
	}
/****************************************************************/
	for(i=8;i>0;i--)					//ѭλ8
	{
		DS1302_CLK=0;					//DS1302_CLK
		temp=dat;						//ݸֵʱ
		DS1302_DAT=(bit)(temp&0x01);	//λŵDS1302_DAT
		DS1302_CLK=1;					//DS1302_CLK
		dat>>=1;						//һλ
	}
	DS1302_CLK=0;						//DS1302_CLK
	DS1302_RST=0;						//λDS1302_RSTֹDS1302ݴ
}

/********************************ݶȡӳ********************************/
unsigned char Read_DS1302(unsigned char addr)
{
	unsigned char i,temp,dat,dat1;		//ַͱ
	P3M0=P3M0|0x20;						//ö˿״̬
	DS1302_RST=0;						//λDS1302_RSTֹDS1302ݴ
	DS1302_CLK=0;						//DS1302_CLK
	DS1302_RST=1;						//λDS1302_RSTʹDS1302ݴ
/********************************͵ַ********************************/
	for(i=8;i>0;i--)					//ѭλ8
	{
		DS1302_CLK=0;					//DS1302_CLK
		temp=addr;						//ѵֵַʱ
		DS1302_DAT=(bit)(temp&0x01);	//ַλŵDS1302_DAT
		DS1302_CLK=1;					//DS1302_CLK
		addr>>=1;						//ַһλ
	}
/********************************ȡ********************************/
	P3M0=P3M0&0xdf;						//ö˿״̬
	for(i=8;i>0;i--)					//ѭλ8
	{
		ACC>>=1;						//ACCһλ
		DS1302_CLK=1;					//DS1302_CLK
		DS1302_CLK=0;					//DS1302_CLK׼ȡ
		ACC_7=DS1302_DAT;				//ȡݣACC_7Ϊݵλ
	}
	DS1302_CLK=0;						//DS1302_CLK
	DS1302_RST=0;						//λDS1302_RSTֹDS1302ݴ
	dat=ACC;							//ACCֵdat
	dat1=dat&0xf0;						//ݽת ȡλ
	dat1>>=4;							//ƶλΪʮλ
	dat=dat&0x0f;						//ȡλΪλ
	dat=dat+dat1*10;					//õʮ
	return dat;							//ʮֵ
}

void Init_DS1302(void)
{
	Write_DS1302(Write_Protect,0x00);		//ȥд
	Write_DS1302(Write_TCR,TCS_1D2K);		//ʼ緽ʽ
	Write_DS1302(Write_Year,Init_Year);		//ʼ
	Write_DS1302(Write_Day,Init_Day);		//ʼ
	Write_DS1302(Write_Month,Init_Month);	//ʼ
	Write_DS1302(Write_Date,Init_Date);		//ʼ
	Write_DS1302(Write_Hour,Init_Hour);		//ʼСʱ
	Write_DS1302(Write_Minute,Init_Minute);	//ʼ
	Write_DS1302(Write_Second,0x00);		//ʼ
	Write_DS1302(Write_Protect,0x80);		//д
}

void Init_DS18B20(void) 
{
	bit x;
	DS18B20_DAT=1;		//DS18B20_DATø
	Delay_10us();		//ʱ
	DS18B20_DAT=0;		//͸λ
	Delay_x10us(50);	//ʱ>480us)
	DS18B20_DAT=1;		//
	Delay_x10us(6);		//ȴ15~60us)
	x=DS18B20_DAT;		//Xֵжϳʼûгɹ18B20ڵĻX=0X=1
	Delay_x10us(24);
}

/********************************һֽ********************************/
unsigned char Read_One_Char(void)
{
	unsigned char i,dat;
	for(i=8;i>0;i--)	//һֽ8λ 
	{
		DS18B20_DAT=1; 
		Delay_10us();
		DS18B20_DAT=0;	//ȴӸ͵ƽ1usϣʹΪߵƽӶź
		Delay_10us();
		dat>>=1; 
		DS18B20_DAT=1; 
		if(DS18B20_DAT) 
		dat|=0x80;
		Delay_x10us(4);	//ÿ̵ĳʱΪ60us֮1usϵĸߵƽָ
	}
	Delay_10us();
	return(dat);
}
/********************************дһֽ********************************/
void Write_One_Char(unsigned char dat)
{
  unsigned char i=0;
  for(i=8;i>0;i--)			//һֽ8λ
  {
	DS18B20_DAT=0;			//ߴӸߵƽ͵ƽдʼź
	Delay_10us();
	DS18B20_DAT=dat&0x01;	//15us֮ڽдλ͵
	Delay_x10us(6);			//15~60us߽֮вǸߵƽд1д0
	DS18B20_DAT=1;
	dat>>=1;
  }
  Delay_10us();				//ڿʼһдǰ1usϵĸߵƽָ
}
/********************************¶ֵλtempLλtempH********************************/
float Read_Temperature(void)
{
	bit Flag;
	unsigned char TempL,TempH;
	unsigned int Temp;
	float Temperature;
	Init_DS18B20();						//ʼ
	Write_One_Char(0xcc);				//кŵĲ
	Write_One_Char(0x44);				//¶ת
	Delay_10us();
	Init_DS18B20();						//ʼ
	Write_One_Char(0xcc);				//кŵĲ
	Write_One_Char(0xbe);				//¶ȼĴͷֱֵΪ¶ȵĵλ͸λ
	TempL=Read_One_Char();				//¶ȵĵλLSB
	TempH=Read_One_Char();				//¶ȵĸλMSB
	Temp=TempH;
	Temp<<=8;
	Temp=Temp|TempL;
	if(Temp>0x7fff)
	{
		Temp=~Temp;
		Temp=Temp+1;
		Flag=1;
	}
	Temperature=((float)Temp)/16;
	return Temperature;
}

void Beep(void)
{
	unsigned int i,j;
	LED_R=0;
	LED_G=1;
	LED_B=1;
	for(i=250;i>0;i--)
	{
		Buzzer=0;
		for(j=400;j>0;j--);
		Buzzer=1;
		for(j=400;j>0;j--);
	}
	LED_R=0;
	LED_G=0;
	LED_B=1;
	for(i=275;i>0;i--)
	{
		Buzzer=0;
		for(j=363;j>0;j--);
		Buzzer=1;
		for(j=363;j>0;j--);
	}
	LED_R=1;
	LED_G=0;
	LED_B=1;
	for(i=300;i>0;i--)
	{
		Buzzer=0;
		for(j=333;j>0;j--);
		Buzzer=1;
		for(j=333;j>0;j--);
	}
	LED_R=1;
	LED_G=0;
	LED_B=0;
	for(i=325;i>0;i--)
	{
		Buzzer=0;
		for(j=308;j>0;j--);
		Buzzer=1;
		for(j=308;j>0;j--);
	}
	LED_R=1;
	LED_G=1;
	LED_B=0;
	for(i=350;i>0;i--)
	{
		Buzzer=0;
		for(j=286;j>0;j--);
		Buzzer=1;
		for(j=286;j>0;j--);
	}
	LED_R=0;
	LED_G=1;
	LED_B=0;
	for(i=375;i>0;i--)
	{
		Buzzer=0;
		for(j=267;j>0;j--);
		Buzzer=1;
		for(j=267;j>0;j--);
	}
	LED_R=0;
	LED_G=0;
	LED_B=0;
	for(i=400;i>0;i--)
	{
		Buzzer=0;
		for(j=250;j>0;j--);
		Buzzer=1;
		for(j=250;j>0;j--);
	}
	LED_R=1;
	LED_G=1;
	LED_B=1;
	Buzzer=1;	
}

void Display(unsigned char a,b,c,d,bit e)
{
	unsigned char temp;
	if((Light_Mode==0)&&(Light_Temp==0))
		temp=0;
	else
		temp=15;
	P0=a;
	P23=0;
	Delay_x10us(temp);
	P23=1;
	Delay_x10us(20-temp);
	P0=b;
	P22=0;
	Delay_x10us(temp);
	P22=1;
	Delay_x10us(20-temp);
	P0=c;
	P21=0;
	Delay_x10us(temp);
	P21=1;
	Delay_x10us(20-temp);
	P0=d;
	P20=0;
	Delay_x10us(temp);
	P20=1;
	Delay_x10us(20-temp);
	Colon=e;
	P24=0;
	Delay_x10us(temp);
	P24=1;
	Delay_x10us(20-temp);
}

void Display_Time(unsigned char mode)
{
	unsigned char year,day,month,date,hour,minute,second,ss;
	year=Read_DS1302(Read_Year);
	day=Read_DS1302(Read_Day);
	month=Read_DS1302(Read_Month);
	date=Read_DS1302(Read_Date);
	hour=Read_DS1302(Read_Hour);
	minute=Read_DS1302(Read_Minute);
	second=Read_DS1302(Read_Second);
	if(ss!=second)
	{
		ss=second;
		Counter_50ms_Timer0=0;
		TH0=0x3c;
		TL0=0xb0;
	}
	switch(mode)
	{
		case 0:
			if(Counter_50ms_Timer0<10)
				Display(Display_Code[hour/10],Display_Code[hour%10],Display_Code[minute/10],Display_Code[minute%10],1);
			else
				Display(Display_Code[hour/10],Display_Code[hour%10],Display_Code[minute/10],Display_Code[minute%10],0);
		break;
		case 1:
			if(Counter_50ms_Timer0<10)
				Display(Display_Code[minute/10],Display_Code[minute%10]|0x80,Display_Code[second/10],Display_Code[second%10],1);
			else
				Display(Display_Code[minute/10],Display_Code[minute%10]|0x80,Display_Code[second/10],Display_Code[second%10],0);
		break;
		case 2:
			Display(Display_Code[2],Display_Code[0],Display_Code[year/10],Display_Code[year%10],0);
		break;
		case 3:
			Display(Display_Code[month/10],Display_Code[month%10]|0x80,Display_Code[date/10],Display_Code[date%10],0);
		break;
		case 4:
			Display(0x40,0x40,0x40,Display_Code[day%16],0);
		break;
	}
}

void Set_Time(void)
{
	static unsigned char year,day,month,date,hour,minute,temp_sw,temp_gw;
	switch(Step)
	{
		case 0:
			year=Read_DS1302(Read_Year);
			day=Read_DS1302(Read_Day);
			month=Read_DS1302(Read_Month);
			date=Read_DS1302(Read_Date);
			hour=Read_DS1302(Read_Hour);
			minute=Read_DS1302(Read_Minute);
			Step++;
		break;
		case 1:
			Temp=year;
			Temp_Min=0;
			Temp_Max=99;
			Step++;
		break;
		case 2:
			if(Counter_50ms_Timer1%10<5)
				Display(Display_Code[2],Display_Code[0],Display_Code[Temp/10],Display_Code[Temp%10],0);
			else
				Display(Display_Code[2],Display_Code[0],0x00,0x00,0);
		break;
		case 3:
			year=Temp;
			Temp=month;
			Temp_Min=1;
			Temp_Max=12;
			Step++;
		break;
		case 4:
			if(Counter_50ms_Timer1%10<5)
				Display(Display_Code[Temp/10],Display_Code[Temp%10]|0x80,Display_Code[date/10],Display_Code[date%10],0);
			else
				Display(0x00,0x00,Display_Code[date/10],Display_Code[date%10],0);
		break;
		case 5:
			month=Temp;
			Temp=date;
			Temp_Min=1;
			switch(month)
			{
				case 1:
					Temp_Max=31;
				break;
				case 2:
					if(year%4==0)
						Temp_Max=29;
					else
						Temp_Max=28;
				break;
				case 3:
					Temp_Max=31;
				break;
				case 4:
					Temp_Max=30;
				break;
				case 5:
					Temp_Max=31;
				break;
				case 6:
					Temp_Max=30;
				break;
				case 7:
					Temp_Max=31;
				break;
				case 8:
					Temp_Max=31;
				break;
				case 9:
					Temp_Max=30;
				break;
				case 10:
					Temp_Max=31;
				break;
				case 11:
					Temp_Max=30;
				break;
				case 12:
					Temp_Max=31;
				break;
			}
			Step++;
		break;
		case 6:
			if(Counter_50ms_Timer1%10<5)
				Display(Display_Code[month/10],Display_Code[month%10]|0x80,Display_Code[Temp/10],Display_Code[Temp%10],0);
			else
				Display(Display_Code[month/10],Display_Code[month%10]|0x80,0x00,0x00,0);
		break;
		case 7:
			date=Temp;
			Temp=day;
			Temp_Min=1;
			Temp_Max=7;
			Step++;
		break;
		case 8:
			if(Counter_50ms_Timer1%10<5)
				Display(0x40,0x40,0x40,Display_Code[Temp%10],0);
			else
				Display(0x40,0x40,0x40,0x00,0);
		break;
		case 9:
			day=Temp;
			Temp=hour;
			Temp_Min=0;
			Temp_Max=23;
			Step++;
		break;
		case 10:
			if(Counter_50ms_Timer1%10<5)
				Display(Display_Code[Temp/10],Display_Code[Temp%10],Display_Code[minute/10],Display_Code[minute%10],1);
			else
				Display(0x00,0x00,Display_Code[minute/10],Display_Code[minute%10],1);
		break;
		case 11:
			hour=Temp;
			Temp=minute;
			Temp_Min=0;
			Temp_Max=59;
			Step++;
		break;
		case 12:
			if(Counter_50ms_Timer1%10<5)
				Display(Display_Code[hour/10],Display_Code[hour%10],Display_Code[Temp/10],Display_Code[Temp%10],1);
			else
				Display(Display_Code[hour/10],Display_Code[hour%10],0x00,0x00,1);
		break;
		case 13:
			minute=Temp;
			Display(Display_Code[hour/10],Display_Code[hour%10],Display_Code[minute/10],Display_Code[minute%10],1);
		break;
		case 14:
			temp_sw=year/10;
			temp_gw=year%10;
			year=temp_sw*16+temp_gw;
			temp_sw=month/10;
			temp_gw=month%10;
			month=temp_sw*16+temp_gw;
			temp_sw=date/10;
			temp_gw=date%10;
			date=temp_sw*16+temp_gw;
			temp_sw=hour/10;
			temp_gw=hour%10;
			hour=temp_sw*16+temp_gw;
			temp_sw=minute/10;
			temp_gw=minute%10;
			minute=temp_sw*16+temp_gw;
			Write_DS1302(Write_Protect,0x00);
			Write_DS1302(Write_TCR,TCS_1D2K);
			Write_DS1302(Write_Year,year);
			Write_DS1302(Write_Day,day);
			Write_DS1302(Write_Month,month);
			Write_DS1302(Write_Date,date);
			Write_DS1302(Write_Hour,hour);
			Write_DS1302(Write_Minute,minute);
			Write_DS1302(Write_Second,0x00);
			Write_DS1302(Write_Protect,0x80);
			Step=0;
			Set_Mode=0;
			Time_Mode=0;
		break;
	}
}

void Display_Temperature(bit temperature_mode)
{
	unsigned char i,sw,gw,sfw,bfw;
	unsigned int Temp;
	if(Power_Mode==0)
		Temp=0;
	else
		Temp=(unsigned int)(Read_Temperature()*100);
	sw=Temp%10000/1000;
	gw=Temp%1000/100;
	sfw=Temp%100/10;
	bfw=Temp%10;
	for(i=10;i>0;i--)
	{
		if(temperature_mode==1)
			Display(Display_Code_Turn[bfw],Display_Code_Turn[sfw],Display_Code_Turn[gw],Display_Code_Turn[sw],1);
		else
			Display(0x8f,Display_Code_Turn[sfw],Display_Code_Turn[gw],Display_Code_Turn[sw],1);
	}
}

void Key_Scan(void)
{
	if(B0==0)
	{
		if(B0_Flag==1)
		{
			if(Set_Mode==1)
			{
				Temp++;
				if(Temp>Temp_Max)
					Temp=Temp_Min;
			}
			else
			{
				if(P32==1)
				{
					Time_Mode++;
					if(Time_Mode>=5)
						Time_Mode=0;
				}
				else
					Temperature_Mode=~Temperature_Mode;
			}
			B0_Flag=0;
		}
	}
	else
		B0_Flag=1;
	if(B1==0)
	{
		if(B1_Flag==1)
		{
			if(Set_Mode==1)
			{
				Temp--;
				if(Temp<Temp_Min)
					Temp=Temp_Max;
			}
			else
			{
				if(P32==1)
				{
					Time_Mode--;
					if(Time_Mode>=5)
						Time_Mode=4;
				}
				else
					Temperature_Mode=~Temperature_Mode;
			}
			B1_Flag=0;
		}
	}
	else
		B1_Flag=1;
	if(B2==0)
	{
		if(B2_Flag==1)
		{
			if(Set_Mode==0)
			{
				if((B0==0)&&(B1==0))
					Set_Mode=1;
				else
					Light_Mode=~Light_Mode;
			}
			else
				Step++;
			B2_Flag=0;
		}
	}
	else
		B2_Flag=1;
}

void Init(void)
{
	AUXR&=0x3F;
	TMOD=0x11;
	TH0=0x3C;
	TL0=0xB0;
	TH1=0x3C;
	TL1=0xB0;
	IT0=1;
	IT1=1;
	IPH=0x06;
	IP=0x0c;
	ET0=1;
	ET1=1;
	EX0=1;
	EX1=1;
	EA=1;
	TR0=1;
	TR1=1;
	P0M0=0xff;
	P2M0=0xff;
	P3M0=0x50;
	Buzzer=1;
	Power_Mode=0;
	Light_Mode=0;
	Light_Temp=0;
}

void main(void)
{
	Init();
	if(Read_DS1302(Read_Second)>0x7f)
		Init_DS1302();
	Read_Temperature();
//	Beep();
	while(1)
	{
		if(P32==1)
		{
			if(Set_Mode==0)
				Display_Time(Time_Mode);
			else
				Set_Time();
		}
		else
		{
			Set_Mode=0;
			Step=0;
			Display_Temperature(Temperature_Mode);
		}
		Key_Scan();
		if(P30==0)
			IAP_CONTR=0x60;
	}
}

void Int0(void) interrupt 0
{
	
}

void Timer0(void) interrupt 1
{
	TH0=0x3c;
	TL0=0xb0;
	Counter_50ms_Timer0++;
}

void Int1(void) interrupt 2
{
	Light_Temp=1;
}

void Timer1(void) interrupt 3
{
	static temp;
	TH1=0x3c;
	TL1=0xb0;
	Counter_50ms_Timer1++;
	if(Counter_50ms_Timer1>=20)
	{
		Counter_50ms_Timer1=0;
		Power_Mode=1;
		if((Light_Mode==0)&&(Light_Temp==1))
			temp++;
		if((temp>=10)||(Light_Mode==1))
		{
			temp=0;
			Light_Temp=0;
		}
	}
}